"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (realm) {
  // ECMA262 25.2.1
  var func = new _index.NativeFunctionValue(realm, "GeneratorFunction", "GeneratorFunction", 1, function (context, args, argCount, NewTarget) {
    // 1. Let C be the active function object.
    var C = func;

    // 2. Let args be the argumentsList that was passed to this function by [[Call]] or [[Construct]].
    args = argCount > 0 ? args : [];

    // 3. Return ? CreateDynamicFunction(C, NewTarget, "generator", args).
    return (0, _create.CreateDynamicFunction)(realm, C, NewTarget, "generator", args);
  });

  return func;
};

var _index = require("../../values/index.js");

var _create = require("../../methods/create.js");
//# sourceMappingURL=GeneratorFunction.js.map